// Copyright (c) 2016, 2018, 2024, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Digital Assistant Service Instance API
//
// API to create and maintain Oracle Digital Assistant service instances.
//

package oda

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// EntityAction Action of an entity
type EntityAction struct {

	// Name of an entity action
	Name *string `mandatory:"true" json:"name"`

	// List of entity action arguments
	Arguments []EntityActionArgument `mandatory:"true" json:"arguments"`

	// Type of CRUD operation for entity action
	CrudType *string `mandatory:"false" json:"crudType"`

	NaturalLanguageMapping *EntityActionNaturalLanguageMapping `mandatory:"false" json:"naturalLanguageMapping"`
}

func (m EntityAction) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m EntityAction) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
