// Copyright (c) 2016, 2018, 2024, Oracle and/or its affiliates.  All rights reserved.
// This software is dual-licensed to you under the Universal Permissive License (UPL) 1.0 as shown at https://oss.oracle.com/licenses/upl or Apache License 2.0 as shown at http://www.apache.org/licenses/LICENSE-2.0. You may choose either license.
// Code generated. DO NOT EDIT.

// Stack Monitoring API
//
// Stack Monitoring API.
//

package stackmonitoring

import (
	"fmt"
	"github.com/oracle/oci-go-sdk/v65/common"
	"strings"
)

// MetricData Metric Details
type MetricData struct {

	// list of data points for the metric for training of baseline
	TrainingDataPoints []DataPoint `mandatory:"true" json:"trainingDataPoints"`

	// list of data points for the metric for evaluation of anomalies
	EvaluationDataPoints []DataPoint `mandatory:"true" json:"evaluationDataPoints"`

	// list of dimensions for the metric
	Dimensions map[string]string `mandatory:"false" json:"dimensions"`
}

func (m MetricData) String() string {
	return common.PointerString(m)
}

// ValidateEnumValue returns an error when providing an unsupported enum value
// This function is being called during constructing API request process
// Not recommended for calling this function directly
func (m MetricData) ValidateEnumValue() (bool, error) {
	errMessage := []string{}

	if len(errMessage) > 0 {
		return true, fmt.Errorf(strings.Join(errMessage, "\n"))
	}
	return false, nil
}
